import unittest
import sys
from pathlib import Path
# Add the project root to sys.path
sys.path.append(str(Path(__file__).resolve().parent.parent))
                
from Direction import *

class DirectionTest(unittest.TestCase):
    def test_Compare(self):
        d = Direction.Degrees(45, 135)
        r = Direction(Angle.Degrees(45), Angle.Degrees(135))
        assert(d == r)

        r = Direction(Angle.Degrees(45 + 360), Angle.Degrees(135 - 360))
        assert (d == r)

    def test_Inverse(self):
        d = Direction.Degrees(45, 135)
        r = Direction.Degrees(-135, -135)
        assert(-d == r)

        d = Direction.Degrees(-45, -135)
        r = Direction.Degrees(135, 135)
        assert(-d == r)

        d = Direction.Degrees(0, 0)
        r = Direction.Degrees(180, 0)
        assert(-d == r)

        d = Direction.Degrees(0, 45)
        r = Direction.Degrees(180, -45)
        assert(-d == r)

    def test_Equality(self):
        d = Direction.Degrees(135, 45)
        r = Direction.Degrees(135, 45)
        assert(d == r)
        r = Direction.Degrees(135 + 360, 45)
        assert(d == r)
        r = Direction.Degrees(135 - 360, 45)
        assert(d == r)

        d = Direction.Degrees(0, 45 + 180);
        r = Direction.Degrees(180, -45)
        assert(d == r)
